import { APIApplicationCommandDMInteraction, APIApplicationCommandGuildInteraction, APIApplicationCommandInteraction, APIDMInteraction, APIGuildInteraction, APIInteraction } from '../payloads/v8/index';
/**
 * A type-guard check for guild interactions.
 * @param interaction The interaction to check against the
 * @returns A boolean that indicates if the interaction was received from a guild
 */
export declare function isGuildInteraction(interaction: APIInteraction): interaction is APIGuildInteraction;
/**
 * A type-guard check for DM interactions.
 * @param interaction The interaction to check against
 * @returns A boolean that indicates if the interaction was received from a direct message
 */
export declare function isDMInteraction(interaction: APIInteraction): interaction is APIDMInteraction;
/**
 * A type-guard check for guild application command interactions.
 * @param interaction The interaction to check against
 * @returns A boolean that indicates if the command interaction was received from a guild
 */
export declare function isApplicationCommandGuildInteraction(interaction: APIApplicationCommandInteraction): interaction is APIApplicationCommandGuildInteraction;
/**
 * A type-guard check for direct message application command interactions.
 * @param interaction The interaction to check against
 * @returns A boolean that indicates if the command interaction was received from a direct message
 */
export declare function isApplicationCommandDMInteraction(interaction: APIApplicationCommandInteraction): interaction is APIApplicationCommandDMInteraction;
//# sourceMappingURL=v8.d.ts.map